#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Run_Au3Stripper=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <GDIPlus.au3>
#include <WinAPI.au3>
#include <WindowsConstants.au3>
#include <WinAPIsysinfoConstants.au3>
#include "BASS.au3"
#include "as2_64\AssembleIt2_64.au3"

#Region AssembleIt2
	#cs _calculateAmplitudes
	use32

	finit

	macro thirdroot
	{
		fsqrt
		fsqrt
		fst st1		; x^1/4

		fsqrt
		fsqrt
		fst st2		; x^1/16

		fsqrt
		fsqrt
		fst st3		; x^1/64

		fsqrt
		fsqrt		; x^1/256

		fmulp
		fmulp
		fmulp		; Approximation von x^(1/3) ~ x^1/4 * x^1/16 * x^1/64 * x^1/256 = x^0.33203125
	}

	define frequencyLength 	dword[esp+16]
	define amplitudes 		dword[esp+8]
	define frequencies 		dword[esp+12]
	define sampleRate 		dword[esp+20]
	define fftBuffer 		dword[esp+4]

	start:
		mov ecx, 0

		mov eax, 4
		mul frequencyLength
		mov frequencyLength, eax

		forloop:
			mov eax, frequencies
			mov eax, [eax + ecx]
			mov edx, 4096
			mul edx	; -> eax

			push eax
			fild dword [esp]
			pop eax		; $iFrequency * 4096 in ST0

			push sampleRate
			fild dword [esp]
			pop sampleRate	; $iChannelFrequency in ST0

			fdivp st1, st0	; $iFrequency * 4096 / $iChannelFrequency -> ST0

			sub esp, 4
			fistp dword [esp] ; Rundet ST0 automatisch
			mov eax, [esp]	; index -> eax
			add esp, 4

			mov edx, 4
			mul edx ; -> eax beinhaltet offset (muss in eax berechnet werden und nicht auf der FPU, da ansonsten der index % 4 <> 0 ist)

			push fftBuffer
			add eax, [esp]		; eax beinhaltet index vom fftbuffer
			pop fftBuffer

			fld dword [eax]
			thirdroot ; st0^(1/3)

			mov edx, amplitudes
			fstp dword [edx + ecx]	; Speichere berechnete Amplitude in pAmplitudes[index] und poppe st0

			mov edx, 4
			add ecx, edx
			cmp ecx, frequencyLength
			jl forloop

		ret
#ce

	$binAmplitudeCode = _AssembleIt2("retbinary", "_calculateAmplitudes")
	$tAmplitudeCodeBuffer = DllStructCreate("byte [" & StringLen($binAmplitudeCode) / 2 - 1 & "]")
	DllStructSetData($tAmplitudeCodeBuffer, 1, $binAmplitudeCode)
	$pAmplitudeCodeBuffer = DllStructGetPtr($tAmplitudeCodeBuffer)
#EndRegion

_BASS_Startup()
_BASS_Init(0)

Global $hStream = _BASS_StreamCreateFile(False, FileOpenDialog("", @DesktopDir, "Alle Dateien (*.*)"), 0, 0, $BASS_SAMPLE_FLOAT)
_BASS_ChannelPlay($hStream, 0)

HotKeySet("{F1}", "_ExitVisualizer")

Global $tBuffer = DllStructCreate("float [2048]")
Global $pBuffer = DllStructGetPtr($tBuffer)
Global $iBuffer = DllStructGetSize($tBuffer)

Global $tRect = DllStructCreate($tagRECT)
_WinAPI_SystemParametersInfo($SPI_GETWORKAREA, 0, DllStructGetPtr($tRect)) ; 0x30 = SPI_GETWORKAREA

Global Const $iWidthGUI = @DesktopWidth / 3
Global Const $iHeightGUI = @DesktopHeight / 3
Global Const $iTaskbarHeight = @DesktopHeight - $tRect.Bottom

Global Const $iVisualizerHeight = $iHeightGUI * 1 ;Schaut redundant aus aber ich wollte nicht den gesamten Code für Demozwecke umformulieren

Global Const $aStrayFrequencies[] = [30, 40, 50, 60, 70, 80, 90, 100, 200, 300, 400, 500, 600, 700, 800, 900, 1000, 2000, 3000, 4000, 5000, 6000, 7000, 8000, 9000, 10000, 20000]
Global Const $aFrequencies = _SubdivideFrequencies($aStrayFrequencies)
Global $aAmplitudes[UBound($aFrequencies)]

_GDIPlus_Startup()

Opt("GUIOnEventMode", 1)
$hVisualizerGUI = GUICreate("", $iWidthGUI, $iHeightGUI, 0, @DesktopHeight - $iHeightGUI - $iTaskbarHeight, $WS_POPUP, BitOr($WS_EX_LAYERED, $WS_EX_TOPMOST, $WS_EX_TRANSPARENT, $WS_EX_TOOLWINDOW))
GUISetBkColor(0xABCDEF, $hVisualizerGUI)
GUISetOnEvent(-3, "_ExitVisualizer")
_WinAPI_SetLayeredWindowAttributes($hVisualizerGUI, 0xABCDEF, 255)

GUISetState(@SW_SHOW, $hVisualizerGUI)

$hGraphics = _GDIPlus_GraphicsCreateFromHWND($hVisualizerGUI)
$hBitmap = _GDIPlus_BitmapCreateFromGraphics($iWidthGUI, $iHeightGUI, $hGraphics)
$hBuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)

$hRedBrush = _GDIPlus_BrushCreateSolid(0xFFFF0000)
$hGreenBrush = _GDIPlus_BrushCreateSolid(0xFF00FF00)
$hOrangePen = _GDIPlus_PenCreate(0xFFFF4500, 2, 2)

Local $aLinePoints[UBound($aFrequencies) + 1 + 1][3]
$aLinePoints[0][0] = UBound($aFrequencies) + 1

$tAmplitudes = DllStructCreate("float [" & UBound($aFrequencies) & "]")
$pAmplitudes = DllStructGetPtr($tAmplitudes)

$tFrequencies = DllStructCreate("int [" & UBound($aFrequencies) & "]")
For $i = 0 To UBound($aFrequencies) - 1
	DllStructSetData($tFrequencies, 1, $aFrequencies[$i], $i + 1)
Next
$pFrequencies = DllStructGetPtr($tFrequencies)

$iCounter = 0
$hTimer = TimerInit()

	$hPath = _GDIPlus_PathCreate2($aLinePoints)
While _BASS_ChannelIsActive($hStream)
	_GDIPlus_GraphicsClear($hBuffer, 0xFFABCDEF)

	$iCounter += 1
	If TimerDiff($hTimer) >= 1000 Then
		ConsoleWrite("Zyklen pro Sekunde: " & $iCounter & @CRLF)
		$iCounter = 0
		$hTimer = TimerInit()
	EndIf

	$iBuffer = _BASS_ChannelGetData($hStream, $pBuffer, $BASS_DATA_FFT4096)

	; DllCallAddress-Variante ist wahnsinnig schnell, viel schneller als der Aufruf durch _AssembleIt2()

	; 250 pures AutoIt
	; fast 270 Berechnung in Assembler

;~ 	_AssembleIt2("none", "_calculateAmplitudes", "ptr", $pBuffer, "ptr", $pAmplitudes, "ptr", $pFrequencies, "int", UBound($aFrequencies), "int", 44100) 		; Zyklen pro Sekunde ~208 (langsamer als pures AutoIt)
	DllCallAddress("none:cdecl", $pAmplitudeCodeBuffer, "ptr", $pBuffer, "ptr", $pAmplitudes, "ptr", $pFrequencies, "int", UBound($aFrequencies), "int", 44100)	; Zyklen pro Sekunde ~266 (x1.28)

	For $i = 0 To UBound($aFrequencies) - 1
		$iBarWidth = $iWidthGUI / UBound($aFrequencies)

		$iAmplitude = _FrequencyGetAmplitude($i)
		$aLinePoints[$i + 1][0] = $i * $iBarWidth
		$aLinePoints[$i + 1][1] = $iHeightGUI - $iVisualizerHeight * $iAmplitude
		$aLinePoints[$i + 1][2] = 0x21 ; 0x00 = Start of Figure, 0x20 = Marker
	Next

	$aLinePoints[UBound($aLinePoints) - 1][0] = $iWidthGUI - 1
	$aLinePoints[UBound($aLinePoints) - 1][1] = $iHeightGUI
	$aLinePoints[UBound($aLinePoints) - 1][2] = 0x01

	_GDIPlus_PathAddLine2($hPath, $aLinePoints) ;Hier werden die Punkte alle gleichzeitig übergeben, damit nicht für jeden einzelnen Punkt ein DllCall gemacht werden muss (beschleunigt das Script um das das doppelte)
	_GDIPlus_GraphicsDrawPath($hBuffer, $hPath)
	_GDIPlus_PathReset($hPath)

	_GDIPlus_GraphicsDrawImage($hGraphics, $hBitmap, 0, 0)
WEnd

_ExitVisualizer()

Func _SubdivideFrequencies($aFrequencies, $iDivision = 10)
	Local $aSubfrequencies[(UBound($aFrequencies) - 1) * $iDivision]

	For $i = 0 To UBound($aFrequencies) - 2
		For $j = 0 To $iDivision - 1
			$aSubfrequencies[$i * $iDivision + $j] = $aFrequencies[$i] + $j * ($aFrequencies[$i + 1] - $aFrequencies[$i]) / $iDivision
		Next
	Next

	Return $aSubfrequencies
EndFunc

Func _Abbreviate($i)
	If $i >= 10000 Then Return Floor($i / 1000) & "k"
	If $i >= 1000 Then Return " " & Floor($i / 1000) & "k"
	If $i < 100 Then Return " " & $i
	Return $i
EndFunc

Func _FrequencyGetAmplitude($iFrequencyIndex)
	Return DllStructGetData($tAmplitudes, 1, $iFrequencyIndex + 1)
;~ 	Return DllStructGetData($tBuffer, 1, $iFrequencyIndex * 4096 / 44100) ^ (1/3)
EndFunc

Func _ExitVisualizer()
	_BASS_ChannelStop($hStream)
	_BASS_StreamFree($hStream)
	_BASS_Free()

	_GDIPlus_PathDispose($hPath)
	_GDIPlus_GraphicsDispose($hBuffer)
	_GDIPlus_BitmapDispose($hGraphics)
	_GDIPlus_GraphicsDispose($hGraphics)
	_GDIPlus_Shutdown()
	Exit 0
EndFunc